<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="名称" prop="careerName">
        <el-input
          v-model="queryParams.careerName"
          placeholder="名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="请选择状态" clearable>
          <el-option
            v-for="dict in dict.type.tb_status"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>

      <el-form-item>
	    <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
<!--      <el-col :span="1.5">-->
<!--        <el-button-->
<!--          type="primary"-->
<!--          plain-->
<!--          icon="el-icon-plus"-->
<!--          size="mini"-->
<!--          @click="handleAdd"-->
<!--          v-hasPermi="['hezhi:careerClass:add']"-->
<!--        >新增</el-button>-->
<!--      </el-col>-->
      <el-col :span="1.5">
        <el-button
          type="info"
          plain
          icon="el-icon-sort"
          size="mini"
          @click="toggleExpandAll"
        >展开/折叠</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table
      v-if="refreshTable"
      v-loading="loading"
      :data="careerClassList"
      row-key="careerId"
      :default-expand-all="isExpandAll"
      :tree-props="{children: 'children', hasChildren: 'hasChildren'}"
    >
<!--      <el-table-column label="父级ID" prop="pid" />-->
<!--      <el-table-column label="层级 0 1 2 " align="center" prop="level" />-->
<!--      <el-table-column label="类型" align="center" prop="type" />-->
      <el-table-column label="名称" align="center" prop="careerName" />
      <el-table-column label="logo1" align="center" prop="careerLogoOne" width="100">
        <template slot-scope="scope" v-if="scope.row.pid !== 0">
          <image-preview :src="scope.row.careerLogoOne" :width="30" :height="30"/>
        </template>
      </el-table-column>
      <el-table-column label="logo2" align="center" prop="careerLogoTwo" width="100">
        <template slot-scope="scope" v-if="scope.row.pid !== 0">
          <image-preview :src="scope.row.careerLogoTwo" :width="30" :height="30"/>
        </template>
      </el-table-column>
<!--      <el-table-column label="备注" align="center" prop="remarks" />-->
      <el-table-column label="排序" align="center" prop="sort" />
      <el-table-column label="状态" align="center" prop="status">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.tb_status" :value="scope.row.status"/>
        </template>
      </el-table-column>
      <el-table-column label="创建时间" align="center" prop="createTime" width="150" show-overflow-tooltip/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['hezhi:careerClass:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-plus"
            @click="handleAdd(scope.row)"
            v-if="scope.row.level !== 2"
            v-hasPermi="['hezhi:careerClass:add']"
          >新增</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-if="scope.row.level !== 0"
            v-hasPermi="['hezhi:careerClass:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 添加或修改职业分类对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="父级" prop="pid">
          <treeselect v-model="form.pid" :options="careerClassOptions" :normalizer="normalizer" placeholder="请选择父级ID" />
        </el-form-item>
        <el-form-item label="logo1" prop="careerLogoOne" v-if="form.pid !== 0">
          <image-upload v-model="form.careerLogoOne" :limit="1"/>
        </el-form-item>
        <el-form-item label="logo2" prop="careerLogoTwo" v-if="form.pid !== 0">
          <image-upload v-model="form.careerLogoTwo" :limit="1"/>
        </el-form-item>
        <el-form-item label="名称" prop="careerName">
          <el-input v-model="form.careerName" placeholder="请输入内容" />
        </el-form-item>
<!--        <el-form-item label="备注" prop="remarks">-->
<!--          <el-input v-model="form.remarks" type="textarea" placeholder="请输入内容" />-->
<!--        </el-form-item>-->
        <el-form-item label="排序" prop="sort">
          <el-input-number v-model="form.sort" :step="1" :min="0" step-strictly />
        </el-form-item>
        <el-form-item label="状态" prop="status">
          <el-radio-group v-model="form.status">
            <el-radio
              v-for="dict in dict.type.tb_status"
              :key="dict.value"
              :label="parseInt(dict.value)"
            >{{dict.label}}</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listCareerClass, getCareerClass, delCareerClass, addCareerClass, updateCareerClass } from "@/api/hezhi/careerClass";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "CareerClass",
  dicts: ['tb_status'],
  components: {
    Treeselect
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 显示搜索条件
      showSearch: true,
      // 职业分类表格数据
      careerClassList: [],
      // 职业分类树选项
      careerClassOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 是否展开，默认全部展开
      isExpandAll: false,
      // 重新渲染表格状态
      refreshTable: true,
      // 查询参数
      queryParams: {
        pid: null,
        level: null,
        type: null,
        careerLogoOne: null,
        careerLogoTwo: null,
        careerName: null,
        remarks: null,
        sort: null,
        status: null,
        publicationTime: null,
        publisher: null,
        deleteTime: null,
        deleteBy: null,
        delFlag: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        careerName: [
          { required: true, message: "名称不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询职业分类列表 */
    getList() {
      this.loading = true;
      listCareerClass(this.queryParams).then(response => {
        this.careerClassList = this.handleTree(response.data, "careerId", "pid");
        this.loading = false;
      });
    },
    /** 转换职业分类数据结构 */
    normalizer(node) {
      if (node.children && !node.children.length) {
        delete node.children;
      }
      return {
        id: node.careerId,
        label: node.careerName,
        children: node.children
      };
    },
	/** 查询职业分类下拉树结构 */
    getTreeselect() {
      listCareerClass().then(response => {
        this.careerClassOptions = [];
        const data = { careerId: 0, careerName: '顶级节点', children: [] };
        data.children = this.handleTree(response.data, "careerId", "pid");
        this.careerClassOptions.push(data);
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        careerId: null,
        pid: null,
        level: null,
        type: null,
        careerLogoOne: null,
        careerLogoTwo: null,
        careerName: null,
        remarks: null,
        sort: null,
        status: 0,
        publicationTime: null,
        publisher: null,
        createTime: null,
        createBy: null,
        updateTime: null,
        updateBy: null,
        deleteTime: null,
        deleteBy: null,
        delFlag: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd(row) {
      this.reset();
      this.getTreeselect();
      if (row != null && row.careerId) {
        this.form.pid = row.careerId;
      } else {
        this.form.pid = 0;
      }
      this.open = true;
      this.title = "添加职业分类";
    },
    /** 展开/折叠操作 */
    toggleExpandAll() {
      this.refreshTable = false;
      this.isExpandAll = !this.isExpandAll;
      this.$nextTick(() => {
        this.refreshTable = true;
      });
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.getTreeselect();
      if (row != null) {
        this.form.pid = row.pid;
      }
      getCareerClass(row.careerId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改职业分类";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.careerId != null) {
            updateCareerClass(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addCareerClass(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal.confirm('是否确认删除职业分类编号为"' + row.careerId + '"的数据项？').then(function() {
        return delCareerClass(row.careerId);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    }
  }
};
</script>
